module XhochY
  module Drossellog
    # Counts the HTTP-Codes send by the server
    class CodeCounter
      # Creates a new CodeCounter instance
      def initialize
        @codes = {}
      end
      
      # Count a access to page with the given HTTP-Code
      def add_access(code, page)
        if page.length > 1
          # remove trailing slash
          page = page.split(/\/$/)[0]
        end
        
        if @codes[code] == nil
          @codes[code] = {}
        end
        
        if @codes[code][page] == nil
          @codes[code][page] = 1
        else
          @codes[code][page] += 1
        end
      end
      
      # return the relevant data of this object as a hash
      def to_hash
        @codes.clone
      end
      
      # return the relevant data as simple, one-dimensinal hash
      def to_simple_hash
        ret = {}
        @codes.each do |k1, c|
          ret[k1] = 0
          c.each do |k2, d|
            ret[k1] += d
          end
        end
        ret
      end
    end #^ CodeCounter
  end #^ Drossellog
end #^ XhochY