require File.join(File.dirname(__FILE__), 'pagecounter.rb');
require File.join(File.dirname(__FILE__), 'ipcounter.rb');
require File.join(File.dirname(__FILE__), 'entrycounter.rb');
require File.join(File.dirname(__FILE__), 'impressioncounter.rb');
require File.join(File.dirname(__FILE__), 'datacounter.rb');
require File.join(File.dirname(__FILE__), 'codecounter.rb');

module XhochY
  module Drossellog
    # Reprents the daily report for 1 Domain
    class DailyReport
      
      # Creates a new XYDailyReport Object
      # 
      # Takes a Hash as information provider
      def initialize(data)
        @ipcounter = IPCounter.new
        @entrycounter = EntryCounter.new
        @impressioncounter = ImpressionCounter.new
        @requestcounter = PageCounter.new
        @datacounter = DataCounter.new
        @codecounter = CodeCounter.new
        
        data['lines'].each do |line|
          @ipcounter.add_user line['ip']
          if line['referrer'] == '-'
            @entrycounter.add_page line['path']
          end
          @impressioncounter.add_page line['path']
          @requestcounter.add_page line['path']
          @datacounter.add_data line['size'].to_i
          @codecounter.add_access line['http_code'], line['path']
        end
      end
      
      # Returns the data of that day as multidimensional a hash
      def get_data
      	data = {
      	  'ip' => @ipcounter.to_hash,
      	  'entrypages' => @entrycounter.to_hash,
          'impressions' => @impressioncounter.to_hash,
          'requests' => @requestcounter.to_hash,
          'data' => @datacounter.to_i,
          'codes' => @codecounter.to_hash,
          'codes_simple' => @codecounter.to_simple_hash
      	}
      end
      
    end #^ DailyReport
  end #^ Drossellog
end #^ XhochY
