require File.join(File.dirname(__FILE__), 'pagecounter.rb');
require File.join(File.dirname(__FILE__), 'impressionblacklist.rb');

module XhochY
  module Drossellog
    # Counts all requests that were done without a referrer and 
    # skips the blacklisted suffixes 
    class EntryCounter < PageCounter
    
      # Count a URL, that has no referrer
      #
      # If the suffix of the path is blacklisted, we won't add it
      def add_page(page)
        if page.length > 1
          # remove trailing slash
          page = page.split(/\/$/)[0]
        end
      
        if ImpressionBlacklist::blacklisted? page
          return false
        end

        if @pages[page]
          @pages[page] += 1
        else
          @pages[page] = 1
        end
      end
    
    end #^ EntryCounter
  end #^ Drossellog
end #^ XhochY
