module XhochY
  module Drossellog
    # List of regexps detecting file which shouldn't be counted
    # as site impressions
    module ImpressionBlacklist
    
    @@blacklist = [
      /.*(.png)$/i,
      /.*(.gif)$/i,
      /.*(.jpg)$/i,
      /.*(.jpeg)$/i,
      /.*(.ico)$/i,
      /.*(.css)$/i,
      /.*(.exe)$/i,
      /.*(.js)$/i,
      /(sitemap.xml)(.gz){0,1}$/i,
      /(robots.txt)$/i
    ]
    
    # Check if the given URL is blacklisted
    def self.blacklisted?(page)
      @@blacklist.each do |rxp|
        if page =~ rxp
          return true
        end
      end
      
      # nothing matched, so it isn't blacklisted
      return false
    end
    
    # Add a regexp which indicates non-page files 
    def self.add_to_blacklist(rxp)
      @@blacklist << rxp
    end
    
    end #^ ImpressionBlacklist
  end #^ Drossellog
end #^ XhochY
